package de.hft.stuttgart.citydoctor2.healing;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.hft.stuttgart.citydoctor2.check.HealingID;
import de.hft.stuttgart.citydoctor2.check.HealingMethod;
import de.hft.stuttgart.citydoctor2.check.ModificationListener;
import de.hft.stuttgart.citydoctor2.check.error.PolygonHoleOutsideError;
import de.hft.stuttgart.citydoctor2.datastructure.LinearRing;

public class HealHoleOutsideError implements HealingMethod {
	
	private static final Logger logger = LogManager.getLogger(HealHoleOutsideError.class);
	
	@Override
	public boolean visit(PolygonHoleOutsideError err, ModificationListener l) {
		logger.debug("Executing Repair for PolygonHoleOutsideError");
		for (LinearRing lr : err.getHolesOutside()) {
			err.getPolygon().removeInnerRing(lr);
		}
		return true;
	}

	@Override
	public HealHoleOutsideError createNew() {
		return new HealHoleOutsideError();
	}

	@Override
	public HealingID getID() {
		return HealingID.P_HOLE_OUTSIDE;
	}

}
